/*
 * Component Name: EIF
 *
 * $Date: 8/23/00 13:56:46 $
 *
 * $Source: src/eif/nontme_eif.h, tec_eif, tec_3.8 $
 *
 * $Revision: 1.4.1.3 $
 *
 * Description:
 *      common functions for TME and non-TME agent libraries
 *
 * (C) COPYRIGHT TIVOLI Systems, Inc. 1994
 * Unpublished Work
 * All Rights Reserved
 * Licensed Material - Property of TIVOLI Systems, Inc.
 */

#ifndef NONTME_EIF_H
#define NONTME_EIF_H

#define E_RESERVED 21

#define E_BAD_HANDLE    (E_RESERVED+8)  /* bad handle specified */
#define	E_NO_MEM		(E_RESERVED+11)	/* no memory available for request */
#define E_SCALL         (E_RESERVED+17) /* system call failed */
#define E_IPC_BROKEN    (E_RESERVED+46) /* IPC shutdown */
#define E_IPC_CORRUPT   (E_RESERVED+52) /* IPC message corrupted */

#undef E_HOST
#define E_HOST          (E_RESERVED+27) /* host inaccessible or host failure */

#ifndef TRUE
#	define TRUE 1
#endif

#ifndef FALSE
#	define FALSE 0
#endif

/*
 * The eipc prefix means EIF IPC. TME libraries contain symbols
 * with the ipc prefix already.
 */

typedef struct eipc_handle {
    int fd;
} eipc_handle_t, *eipc_handle_p_t;


typedef int eipc_error_t;

#define HDR_DATA_LEN 2000

/* for AS/400 store TOKEN in ascii instead of it's inherent EBCDIC */
#ifdef OS400
   #define TOKEN "\x3C\x53\x54\x41\x52\x54\x3E\x3E"
#else
   #define TOKEN "<START>>"
#endif

typedef struct eipc_msg_hdr {
    char     token[8];
    unsigned msg_id;
    unsigned msg_from;
    unsigned msg_to;
    unsigned msg_type;
    unsigned ipc_msg_type;
    unsigned msg_len;
    unsigned hdr_data_len;
    char     hdr_data[HDR_DATA_LEN];
} eipc_msg_hdr_t, *eipc_msg_hdr_p_t;

extern eipc_handle_p_t eipc_create_remote_client(unsigned, unsigned short, eipc_error_t *);
extern void eipc_shutdown( eipc_handle_p_t );
extern void eipc_destroy_handle( eipc_handle_p_t );
extern int  eipc_send( eipc_handle_p_t, char *, long, long, long, eipc_error_t *);

#endif
