/*
 * Component Name: TEC
 *
 * Dependencies:
 *
 * $Date: 4/30/01 15:33:08 $
 *
 * $Source: src/bim_server/tec_utils/tec_defines.h, tec, tec_3.8 $
 *
 * $Revision: 1.9.1.5 $
 *
 *
 * (C) COPYRIGHT TIVOLI Systems, Inc. 1999
 * Unpublished Work
 * All Rights Reserved
 * Licensed Material - Property of TIVOLI Systems, Inc.
 */

#ifndef _TEC_DEFINES_H
#define _TEC_DEFINES_H

#ifndef ADAPTERS_ONLY_UNIX
#ifndef OS400
#ifndef NW4
#	ifdef ENDPOINT_BUILD
#		include "mrt/defines.h"
#	elif !defined(NON_TME)
#		include "tivoli/defines.h"
#	endif
#endif
#endif
#endif

#ifndef EXTERN_DECL
#	if defined(__cplusplus)
#		define EXTERN_DECL(entry, args) extern "C" entry args
#	elif defined(__STDC__) || defined(STDC_SRC_COMPATIBLE)  || defined(__EXTENDED__)
#		define EXTERN_DECL(entry, args) extern entry args
#	else
#		define EXTERN_DECL(entry, args) extern entry()
#	endif
#endif

#ifndef EXTERN_DLLDATA
#	if defined(__cplusplus)
#		ifdef WIN32
#			define EXTERN_DLLDATA(entry) extern "C" __declspec(dllimport) entry 
#		else
#			define EXTERN_DLLDATA(entry) extern "C" entry 
#		endif
#	elif defined(__STDC__) || defined(STDC_SRC_COMPATIBLE)  || defined(__EXTENDED__)
#		ifdef WIN32
#			define EXTERN_DLLDATA(entry) extern __declspec(dllimport) entry 
#		else
#			define EXTERN_DLLDATA(entry) extern entry 
#		endif
#	else
#		ifdef WIN32
#			define EXTERN_DLLDATA(entry) extern __declspec(dllimport) entry
#		else
#			define EXTERN_DLLDATA(entry) extern entry 
#		endif
#	endif
#endif

#ifndef EXTERN_VAR
#	if defined(__cplusplus)
#		define EXTERN_VAR(entry) extern "C" entry 
#	elif defined(__STDC__) || defined(STDC_SRC_COMPATIBLE)  || defined(__EXTENDED__)
#		define EXTERN_VAR(entry) extern entry 
#	else
#		define EXTERN_VAR(entry) extern entry 
#	endif
#endif

#ifndef STATIC_DECL
#	if defined(__cplusplus)
#   	define STATIC_DECL(entry, args) static entry args
#	elif defined(__STDC__) || defined(STDC_SRC_COMPATIBLE)  || defined(__EXTENDED__)
#   	define STATIC_DECL(entry, args) static entry args
#	else
#   	define STATIC_DECL(entry, args) static entry()
#	endif
#endif

#ifndef ARGS_DECL
#	if defined(__cplusplus)
#   	define ARGS_DECL(args) args
#	elif defined(__STDC__) || defined(STDC_SRC_COMPATIBLE)  || defined(__EXTENDED__)
#   	define ARGS_DECL(args) args
#	else
#   	define ARGS_DECL(args) ()
#	endif
#endif

#ifndef VOID_DECL
#	if defined(__cplusplus)
#		define VOID_DECL void
#	elif defined(__STDC__) || defined(STDC_SRC_COMPATIBLE)  || defined(__EXTENDED__)
#		define VOID_DECL void
#	else
#		define VOID_DECL
#	endif
#endif

#ifndef CODE_ID
#define CODE_ID(id) \
static struct code_id {\
    char *_str;\
    struct code_id *_ref;\
} _code_id = {\
    id,\
    &_code_id\
};
#endif

#define TEC_SERVER_NAME		"tec_server"
#define TEC_SERVER_NUMBER	100033057
#define TEC_VERSION_NUMBER	1

#endif
