/*
 * Component Name: EIF
 *
 * Dependencies:
 *
 * $Date: 5/3/01 10:02:31 $
 *
 * $Source: src/eif/tec_rpc.h, tec_eif, tec_3.8 $
 *
 * $Revision: 1.6 $
 *
 * (C) COPYRIGHT TIVOLI Systems, Inc. 1999
 * Unpublished Work
 * All Rights Reserved
 * Licensed Material - Property of TIVOLI Systems, Inc.
 */

#ifndef _TEC_RPC_H
#define _TEC_RPC_H

#ifdef WIN32
#	include <winsock.h>
#	include "rpc/types.h" /* Found in export/.../TME/TEC/rpc (from 'sunrpc') */
#	define _bool_t_defined
#else
#	include <netinet/in.h>
#	include <sys/socket.h>
	/*
	 * This bizarre define for AIX is to force the inclusion
	 * of the declaration for struct rpcent and the function
	 * getrpcbyname from header file netdb.h
	 */
#	if defined(AIX) && !defined(_XOPEN_EXTENDED_SOURCE)
#		define _XOPEN_EXTENDED_SOURCE
#		include <netdb.h>
#		undef _XOPEN_EXTENDED_SOURCE
#	else
#		include <netdb.h>
#	endif

	/*
	 * rpc/types.h (included by rpc/rpc.h) defines 'bool_t'.  But so does
	 * tivoli/types.h (included by tivoli/defines.h).  So we define
	 * _bool_t_defined to silence the warnings from tivoli/types.h.
	 * 
	 * rpc/rpc.h exists on SVR4, but it includes some kerberos headers which
	 * get confused with Tivoli's kerberos headers and compilation errors
	 * result.  So we have to be more granular with the rpc/ headers that we
	 * include.
	 */
#	if defined(SVR4) && !defined(DGUX) && !defined(LINUX) && !defined(IRIX5) && !defined(SEQUENT)
		/*
		 * Because mrt/tiv_mrt.h includes mrt/base_types.h which redefines
		 * bool_t (without checking _boo_t_defined), causing a compilation
		 * error.  So we'll have to live with an undeclared reference to
		 * pmap_getport().
		 */
#		ifndef ENDPOINT_BUILD
#			include <tiuser.h>
#			include <rpc/types.h>
#			include <rpc/auth.h>
#			include <rpc/rpcent.h>
#			define _bool_t_defined
#		endif
#	else
#	   ifndef OS400
#		include <rpc/rpc.h>
#	   endif
#		define _bool_t_defined
#	endif

#	ifndef OS2
#		include <arpa/inet.h>
#	endif
#endif

	/* See earlier comment about tiv_mrt.h */
#	if !defined(SVR4) || !defined(ENDPOINT_BUILD)
#	    if !defined(OS400)
#		ifdef OS2
#			include "rpc/pmap_cln.h"
#		else
#			include "rpc/pmap_clnt.h"
#		endif
#	    endif
#	endif

#include <stdlib.h>

#ifdef WIN32
#	include "cpl/msvc_stat_macros.h"
#	ifndef S_ISBLK
#		define	S_ISBLK(a)	(a&0)
#	endif

#	ifndef S_IRUSR
#		define	S_IRUSR		0
#	endif

#	ifndef S_IXUSR
#		define	S_IXUSR		0
#	endif
#endif

#endif
